package dev.shadowsoffire.apotheosis.mixin;

import org.spongepowered.asm.mixin.injection.Redirect;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.ListTag;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.MobType;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import java.util.Map;
import java.util.Iterator;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixInstance;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.socket.SocketHelper;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.util.RandomSource;
import org.spongepowered.asm.mixin.Overwrite;
import java.util.Set;
import dev.shadowsoffire.apotheosis.ench.table.RealEnchantmentHelper;
import java.util.Collections;
import net.minecraft.world.item.enchantment.EnchantmentInstance;
import java.util.List;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import org.spongepowered.asm.mixin.Mixin;

@Mixin({ EnchantmentHelper.class })
public class EnchantmentHelperMixin
{
    @Overwrite
    public static List<EnchantmentInstance> m_44817_(final int power, final ItemStack stack, final boolean allowTreasure) {
        return RealEnchantmentHelper.getAvailableEnchantmentResults(power, stack, allowTreasure, (Set)Collections.emptySet());
    }
    
    @Overwrite
    public static List<EnchantmentInstance> m_220297_(final RandomSource pRandom, final ItemStack pItemStack, final int pLevel, final boolean pAllowTreasure) {
        return RealEnchantmentHelper.selectEnchantment(pRandom, pItemStack, pLevel, 15.0f, 0.0f, 0.0f, pAllowTreasure, (Set)Collections.emptySet());
    }
    
    @Inject(at = { @At("RETURN") }, method = { "getDamageProtection(Ljava/lang/Iterable;Lnet/minecraft/world/damagesource/DamageSource;)I" }, cancellable = true)
    private static void apoth_getDamageProtection(final Iterable<ItemStack> stacks, final DamageSource source, final CallbackInfoReturnable<Integer> cir) {
        int prot = cir.getReturnValueI();
        for (final ItemStack s : stacks) {
            prot += SocketHelper.getGems(s).getDamageProtection(source);
            final Map<DynamicHolder<? extends Affix>, AffixInstance> affixes = AffixHelper.getAffixes(s);
            for (final AffixInstance inst : affixes.values()) {
                prot += inst.getDamageProtection(source);
            }
        }
        cir.setReturnValue((Object)prot);
    }
    
    @Inject(at = { @At("RETURN") }, method = { "getDamageBonus(Lnet/minecraft/world/item/ItemStack;Lnet/minecraft/world/entity/MobType;)F" }, cancellable = true)
    private static void apoth_getDamageBonus(final ItemStack stack, final MobType type, final CallbackInfoReturnable<Float> cir) {
        float dmg = cir.getReturnValueF();
        dmg += SocketHelper.getGems(stack).getDamageBonus(type);
        final Map<DynamicHolder<? extends Affix>, AffixInstance> affixes = AffixHelper.getAffixes(stack);
        for (final AffixInstance inst : affixes.values()) {
            dmg += inst.getDamageBonus(type);
        }
        cir.setReturnValue((Object)dmg);
    }
    
    @Inject(at = { @At("TAIL") }, method = { "doPostDamageEffects(Lnet/minecraft/world/entity/LivingEntity;Lnet/minecraft/world/entity/Entity;)V" })
    private static void apoth_doPostDamageEffects(final LivingEntity user, final Entity target, final CallbackInfo ci) {
        if (user == null) {
            return;
        }
        for (final ItemStack s : user.m_20158_()) {
            SocketHelper.getGems(s).doPostAttack(user, target);
            final Map<DynamicHolder<? extends Affix>, AffixInstance> affixes = AffixHelper.getAffixes(s);
            for (final AffixInstance inst : affixes.values()) {
                final int old = target.f_19802_;
                target.f_19802_ = 0;
                inst.doPostAttack(user, target);
                target.f_19802_ = old;
            }
        }
    }
    
    @Inject(at = { @At("TAIL") }, method = { "doPostHurtEffects(Lnet/minecraft/world/entity/LivingEntity;Lnet/minecraft/world/entity/Entity;)V" })
    private static void apoth_doPostHurtEffects(final LivingEntity user, final Entity attacker, final CallbackInfo ci) {
        if (user == null) {
            return;
        }
        for (final ItemStack s : user.m_20158_()) {
            SocketHelper.getGems(s).doPostHurt(user, attacker);
            final Map<DynamicHolder<? extends Affix>, AffixInstance> affixes = AffixHelper.getAffixes(s);
            for (final AffixInstance inst : affixes.values()) {
                inst.doPostHurt(user, attacker);
            }
        }
    }
    
    @Redirect(method = { "getTagEnchantmentLevel" }, at = @At(value = "INVOKE", target = "Lnet/minecraft/nbt/ListTag;getCompound(I)Lnet/minecraft/nbt/CompoundTag;", remap = true), remap = false)
    private static CompoundTag apoth_reverseLoopOrder(final ListTag tags, final int index) {
        return tags.m_128728_(tags.size() - 1 - index);
    }
}
